function tetrisCopyright
% TETRISCOPYRIGHT   - Show Copyright Screen

global w;
global winRect;

global Flip_Interval;
global Frame_Interval;

global tex_Copyright size_Copyright;
global tex_CopyPsych isze_CopyPsych;
global tex_Intro1 size_Intro1;      
global tex_Intro2 size_Intro2;  
global tex_Intro3 size_Intro3;  

global tex_TetrisTitle
global size_TetrisTitle

global MusicSource;

global ResFactor;

stay_time_copyright = 1.5;  % the text will stay on screen for this time
stay_time_psych = 1.5;
stay_time_intro = 1.3;
fade_time = 1;          % The fading process will last for this period of time


while KbCheck
end
% alSourcePlay(MusicSource);  % Start the music
last_flip = GetSecs;

%% 'Stellari Studio'

for i = 1:fade_time/Frame_Interval
    Screen('DrawTexture', w, tex_Copyright, [], winRect, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

for i = 1:stay_time_copyright/Frame_Interval
    Screen('DrawTexture', w, tex_Copyright, [], winRect);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

for i = 1:fade_time/Frame_Interval
    Screen('DrawTexture', w, tex_Copyright, [], winRect, [], [], 1 - i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

%% 'Psychtoolbox 3'
for i = 1:fade_time/Frame_Interval
    Screen('DrawTexture', w, tex_CopyPsych, [], winRect, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

for i = 1:stay_time_psych/Frame_Interval
    Screen('DrawTexture', w, tex_CopyPsych, [], winRect);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

for i = 1:fade_time/Frame_Interval
    Screen('DrawTexture', w, tex_CopyPsych, [], winRect, [], [], 1 - i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
end

%% Obsolete Codes 
% 
% for i=1:fade_step:255
%     Screen('DrawTexture', w, tex_Copyright, [], [], [], [], i/255);
%     Screen('Flip',w);
% end
% WaitSecs(stay_time_copyright);
% for i=255:-fade_step:1
%     Screen('DrawTexture', w, tex_Copyright, [], [], [], [], i/255);
%     Screen('Flip',w);
% end
% 
% % 'Psychtoolbox 3'
% for i=1:fade_step:255
%     Screen('DrawTexture', w, tex_CopyPsych, [], [], [], [], i/255);
%     Screen('Flip',w);
% end
% WaitSecs(between_time);
% for i=255:-fade_step:1
%     Screen('DrawTexture', w, tex_CopyPsych, [], [], [], [], i/255);
%     Screen('Flip',w);
% end

try
%% Intro 1

% Get the rect for the text
rectIntro1 = [(winRect(3)-size_Intro1(2))/2 (winRect(4)-size_Intro1(1))/2];
rectIntro1 = [rectIntro1, rectIntro1] + [0 0 size_Intro1(2) size_Intro1(1)];

% The vertical to horizontal ratio
y2x_Intro1 = size_Intro1(1)./size_Intro1(2);

% Thus, the picture shall be expanded in different sizes at
% different directions
texsize_ratio = [1 y2x_Intro1 1 y2x_Intro1];

% the tex will be this time larger than its original size after 1 sec
expand_rate = [-18 -18 18 18];  
                                
last_flip = GetSecs;

% fade in and expand
for i = 1:fade_time/Frame_Interval
    rectIntro1 = rectIntro1 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        rethrow(lasterror);     % Just throw an error here to break from the cycle
                                % The content of the error does not matter
    end
end

% expand only
for i = 1:stay_time_intro/Frame_Interval
    rectIntro1 = rectIntro1 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], 1);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
       rethrow(lasterror); 
    end
end

% expand and fade out
for i = 1:fade_time/Frame_Interval
    rectIntro1 = rectIntro1 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], 1-i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        rethrow(lasterror); 
    end
end


%% Intro 2
rectIntro2 = [(winRect(3)-size_Intro2(2))/2 (winRect(4)-size_Intro2(1))/2];
rectIntro2 = [rectIntro2, rectIntro2] + [0 0 size_Intro2(2) size_Intro2(1)];
y2x_Intro2 = size_Intro2(1)./size_Intro2(2);

expand_rate = [-18 -18 18 18];
texsize_ratio = [1 y2x_Intro2 1 y2x_Intro2];

last_flip = GetSecs;

% fade in and expand
for i = 1:fade_time/Frame_Interval
    rectIntro2 = rectIntro2 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        rethrow(lasterror); 
    end
end

% expand only
for i = 1:stay_time_intro/Frame_Interval
    rectIntro2 = rectIntro2 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], 1);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
       rethrow(lasterror); 
    end
end

% expand and fade out
for i = 1:fade_time/Frame_Interval
    rectIntro2 = rectIntro2 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], 1-i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
     if KbCheck
        rethrow(lasterror); 
    end
end

%% Intro 3

rectIntro3 = [(winRect(3)-size_Intro3(2))/2 (winRect(4)-size_Intro3(1))/2];
rectIntro3 = [rectIntro3, rectIntro3] + [0 0 size_Intro3(2) size_Intro3(1)];
y2x_Intro3 = size_Intro3(1)./size_Intro3(2);
expand_rate = [-18 -18 18 18];
texsize_ratio = [1 y2x_Intro3 1 y2x_Intro3];

last_flip = GetSecs;
% fade in and expand
for i = 1:fade_time/Frame_Interval
    rectIntro3 = rectIntro3 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        error;
    end
end

% expand only
for i = 1:stay_time_intro/Frame_Interval
    rectIntro3 = rectIntro3 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], 1);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        error;
    end
end

% expand and fade out
for i = 1:fade_time/Frame_Interval
    rectIntro3 = rectIntro3 + expand_rate.*Frame_Interval.*texsize_ratio;
    Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], 1-i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        error;
    end
end

%% Title fade in

lefttop = [(winRect(3) - size_TetrisTitle(2))./2, 250.*ResFactor(2)];
rect = [lefttop lefttop+size_TetrisTitle([2 1])];

for i = 1:fade_time/Frame_Interval
    Screen('DrawTexture', w, tex_TetrisTitle, [], rect, [], [], i*Frame_Interval/fade_time);
    last_flip = Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    if KbCheck
        error;
    end
end

aaaa = 3 
%% Obsolete Code Segment
% % Intro 1
% rectIntro1 = [(winRect(3)-size_Intro1(2))/2 (winRect(4)-size_Intro1(1))/2];
% rectIntro1 = [rectIntro1, rectIntro1] + [0 0 size_Intro1(2) size_Intro1(1)];
% y2x_Intro1 = size_Intro1(1)./size_Intro1(2);
% steps = 0;
% expand_rate = [-0.3 -0.3 0.3 0.3];  % 0.3 per frame
% texsize_ratio = [1 y2x_Intro1 1 y2x_Intro1]
% for i=1:fade_step:255
%     rectIntro1 = rectIntro1 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], i/255);
%     Screen('Flip',w);
% end
% for i=1:fade_step:255
%     rectIntro1 = rectIntro1 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], 1);
%     Screen('Flip',w);
% end
% for i=255:-fade_step:1
%     rectIntro1 = rectIntro1 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro1, [], rectIntro1, [], [], i/255);
%     Screen('Flip',w);
% end

% Intro 3
% rectIntro2 = [(winRect(3)-size_Intro2(2))/2 (winRect(4)-size_Intro2(1))/2];
% rectIntro2 = [rectIntro2, rectIntro2] + [0 0 size_Intro2(2) size_Intro2(1)];
% y2x_Intro2 = size_Intro2(1)./size_Intro2(2);
% steps = 0;
% expand_rate = [-0.3 -0.3 0.3 0.3];
% texsize_ratio = [1 y2x_Intro2 1 y2x_Intro2]
% for i=1:fade_step:255
%     rectIntro2 = rectIntro2 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], i/255);
%     Screen('Flip',w);
% end
% for i=1:fade_step:255
%     rectIntro2 = rectIntro2 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], 1);
%     Screen('Flip',w);
% end
% for i=255:-fade_step:1
%     rectIntro2 = rectIntro2 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro2, [], rectIntro2, [], [], i/255);
%     Screen('Flip',w);
% end
% 
% % Intro 3
% rectIntro3 = [(winRect(3)-size_Intro3(2))/2 (winRect(4)-size_Intro3(1))/2];
% rectIntro3 = [rectIntro3, rectIntro3] + [0 0 size_Intro3(2) size_Intro3(1)];
% y2x_Intro3 = size_Intro3(1)./size_Intro3(2);
% steps = 0;
% expand_rate = [-0.3 -0.3 0.3 0.3];
% texsize_ratio = [1 y2x_Intro3 1 y2x_Intro3]
% for i=1:fade_step:255
%     rectIntro3 = rectIntro3 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], i/255);
%     Screen('Flip',w);
% end
% for i=1:fade_step:255
%     rectIntro3 = rectIntro3 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], 1);
%     Screen('Flip',w);
% end
% for i=255:-fade_step:1
%     rectIntro3 = rectIntro3 + expand_rate.*texsize_ratio;
%     Screen('DrawTexture', w, tex_Intro3, [], rectIntro3, [], [], i/255);
%     Screen('Flip',w);
% end
catch
%     i
%     fprintf('Error occured!');
    Screen('Flip',w, last_flip + Frame_Interval - 0.5 * Flip_Interval);
    return;
end
