function tetrisLoader
% TETRISLOADER      - Load Resources and Initialize Graphic Settings

global w;
global winRect;

global ResFactor;

global SCOREBOARD_XY
global SCOREBOARD_SIZE;
global LINESCLEARED_XY;
global LINESCLEARED_SIZE;
global LINESTOCLEAR_XY;
global LINESTOCLEAR_SIZE;
global NEXTTETRADPROMPT_XY
global NEXTTETRADPROMPT_SIZE
global CURRENTLEVELPROMPT_XY
global CURRENTLEVELPROMPT_SIZE

global SCOREBOARDWHOLE_XY
global SCOREBOARDWHOLE_SIZE

global tex_BlockShade;
global tex_Copyright size_Copyright;
global tex_CopyPsych size_CopyPsych;
global tex_Intro1 size_Intro1;
global tex_Intro2 size_Intro2;
global tex_Intro3 size_Intro3;
% global tex_ScoreBoard size_ScoreBoard rect_ScoreBoard;
% global tex_LinesCleared size_LinesCleared rect_LinesCleared;
% global tex_LinesToNextLevel size_LinesToNextLevel rect_LinesToNextLevel;
% global tex_NextTetrad size_NextTetrad rect_NextTetrad;
% global tex_CurrentLevel size_CurrentLevel rect_CurrentLevel;
global tex_ScoreBoardWhole size_ScoreBoardWhole rect_ScoreBoardWhole;
global tex_TetrisTitle size_TetrisTitle
global tex_GameOver size_GameOver
global tex_Ending size_Ending

global Graph_Dir;
global Music_Dir;

global MusicBuffer

global OpeningMusicBuffer

global CreditsMusicBuffer
global CreditsScrollingTime

global GameOverMusicBuffer

global MusicSource

global MusicFileNum

global MusicVolume
global SoundVolume

global AL;

Screen('BlendFunction',w,GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
%%Loading Progress Bar
progbarDim = [winRect(1) winRect(4).*0.75 winRect(1) winRect(4).*0.80];
progbarColor = [0 128 255];
progbarMin = [0 0 winRect(3)./30 0];  % The minimum unit of the progress bar
Screen('TextFont', w, 'Arial Black');
Screen('TextSize', w, 32);
%% Load Textures:
[arr_BlockShade, arr_Blockmap, arr_BlockAlpha] = imread([Graph_Dir  'block3.png']);
arr_BlockShade(:,:,4) = arr_BlockAlpha; % Append alpha channel to rgb data
arr_BlockShade = uint8(arr_BlockShade);
tex_BlockShade = Screen('MakeTexture',w, arr_BlockShade);
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + progbarMin);
Screen('Flip', w);

[arr_Copyright] = imread([Graph_Dir 'StCopyHl.png']);
arr_Copyright = uint8(arr_Copyright);
tex_Copyright = Screen('MakeTexture', w, arr_Copyright);
size_Copyright = size(arr_Copyright).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 2*progbarMin);
Screen('Flip', w);

[arr_CopyPsych] = imread([Graph_Dir 'StPsych.png']);
arr_CopyPsych = uint8(arr_CopyPsych);
tex_CopyPsych = Screen('MakeTexture', w, arr_CopyPsych);
size_CopyPsych = size(arr_CopyPsych).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 3*progbarMin);
Screen('Flip', w);


[arr_Intro1] = imread([Graph_Dir 'tetrIntroSmall1.png']);
tex_Intro1 = Screen('MakeTexture', w, arr_Intro1);
size_Intro1 = size(arr_Intro1).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 4*progbarMin);
Screen('Flip', w);

[arr_Intro2] = imread([Graph_Dir 'tetrIntroSmall2.png']);
tex_Intro2 = Screen('MakeTexture', w, arr_Intro2);
size_Intro2 = size(arr_Intro2).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 5*progbarMin);
Screen('Flip', w);


[arr_Intro3] = imread([Graph_Dir 'tetrIntroSmall3.png']);
tex_Intro3 = Screen('MakeTexture', w, arr_Intro3);
size_Intro3 = size(arr_Intro3).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 6*progbarMin);
Screen('Flip', w);


[arr_ScoreBoardWhole arr_Map arr_Alpha] = imread([Graph_Dir 'ScoreBoard4.png']);
arr_ScoreBoardWhole(:,:,4) = arr_Alpha;
arr_ScoreBoardWhole = uint8(arr_ScoreBoardWhole);
tex_ScoreBoardWhole = Screen('MakeTexture', w, arr_ScoreBoardWhole);
[nRows nCols nColors] = size(arr_ScoreBoardWhole);   % nColors is useless except helping get correct nRows and nCols
size_ScoreBoardWhole = [nCols nRows].* SCOREBOARDWHOLE_SIZE;   % Do not multiply ResFactor here
rect_ScoreBoardWhole = SCOREBOARDWHOLE_XY([1 2 1 2]) + [0 0 size_ScoreBoardWhole];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 9*progbarMin);
Screen('Flip', w);


[arr_TetrisTitle] = imread([Graph_Dir 'tetrisTitle.png']);
tex_TetrisTitle = Screen('MakeTexture', w, arr_TetrisTitle);
arr_TetrisTitle =uint8(arr_TetrisTitle);
size_TetrisTitle = size(arr_TetrisTitle).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 10*progbarMin);
Screen('Flip', w, [], 1);

[arr_GameOver arr_Map arr_Alpha] = imread([Graph_Dir 'GameOver.png']);
arr_GameOver(:,:,4) = arr_Alpha;
arr_GameOver = uint8(arr_GameOver);
tex_GameOver = Screen('MakeTexture', w, arr_GameOver);
size_GameOver = size(arr_GameOver).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 11*progbarMin);
Screen('Flip', w, [], 1);


[arr_Ending arr_Map arr_Alpha] = imread([Graph_Dir 'Ending.png']);
arr_Ending(:,:,4) = arr_Alpha;
arr_Ending = uint8(arr_Ending);
tex_Ending = Screen('MakeTexture', w, arr_Ending);
size_Ending = size(arr_Ending).*[ResFactor([2 1]) 1];
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 12*progbarMin);
Screen('Flip', w, [], 1);

%% Load Music
% InitializeMatlabOpenAL(2);
% % % % % Generate sound buffers and get errors::
% music = [0];    % Mute all music
% gamemusic = [0];
% freq = 44100;
% MusicBuffer = alGenBuffers(1);
% alGetString(alGetError)
% OpeningMusicBuffer = alGenBuffers(1);
% alGetString(alGetError)
% CreditsMusicBuffer = alGenBuffers(1);
% alGetString(alGetError)
% GameOverMusicBuffer = alGenBuffers(1);
% alGetString(alGetError)
% % % 
% % % % Read opening music data
% % % [music freq] = mp3read([Music_Dir 'Opening.mp3']);
% % % music = int16(music * 32767);
% alBufferData(OpeningMusicBuffer, AL.FORMAT_MONO16, music, length(music)*2, freq);
% % % clear music
% % % DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
% % % Screen('FillRect', w, progbarColor, progbarDim + 15*progbarMin);
% % % Screen('Flip', w);
% % % % Read ingame musics
% % % music = cell(1,MusicFileNum);
% % % for i = 1:MusicFileNum
% % %     [music{i} freq] = mp3read([Music_Dir num2str(i) '.mp3']);
% % %     music{i} = int16(music{i} * 32767);
% % %     size(music{i});
% % %     DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
% % %     Screen('FillRect', w, progbarColor, progbarDim + (15 + i*(25-15)./MusicFileNum) *progbarMin);
% % %     Screen('Flip', w);
% % % end
% % % 
% % % gamemusic = int16([music{1}; music{2}; music{3}]);    % Poor coding here
% alBufferData(MusicBuffer, AL.FORMAT_MONO16, gamemusic, length(gamemusic)*2, freq);
% % % clear music
% % % 
% % % % Read 'credits' music
% % % [music freq] = mp3read([Music_Dir 'Credits.mp3']);
% % % CreditsScrollingTime = length(music)./freq; % Get the time(in seconds)
CreditsScrollingTime = 37; % 37 seconds to finish the credit text scroll
% % % music = int16(music * 32767);
% alBufferData(CreditsMusicBuffer, AL.FORMAT_MONO16, music, length(music)*2, freq);
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 29*progbarMin);
Screen('Flip', w,  [], 1);
% % % clear music
% Create a sound source:
% MusicSource = alGenSources(1);
% 
% % Attach the opening MusicBuffer to it: The source will play the buffers sound data.
% alSourceQueueBuffers(MusicSource, 1, OpeningMusicBuffer);
% 
% % Switch source to looping playback: It will repeat playing the buffer until
% % its stopped.
% alSourcei(MusicSource, AL.LOOPING, AL.TRUE);
% 
% % Set emission volume to 100%, aka a gain of 1.0:
% alSourcef(MusicSource, AL.GAIN, MusicVolume./10);
% 
% alListenerfv(AL.POSITION, [0, 0, 0]);
% alListenerfv(AL.VELOCITY, [0, 0, 0]);
% alListenerfv(AL.ORIENTATION, [0, 0, -1, 0, 1, 0]);

% alSourcePlay(MusicSource);

%%
rand('state', sum(100*clock));    % Users of MATLAB before version 7.4 may experience problems here
%% Init Menu
menuInit;
KbName('UnifyKeyNames')
DrawFormattedText(w, 'LOADING...','center','center',[255 255 255]);
Screen('FillRect', w, progbarColor, progbarDim + 30*progbarMin);
Screen('Flip', w);
%% Quit

ListenChar(2);
