function fail_flag = addTetradToPlayfield(blkMatrix, TetradX, TetradY, colorIndex)
% ADDTETRADTOPLAYFIELD - Add a settle block to the playfield and
% playfield_color
%
% Usage:
% addTetradToPlayfield(blkMatrix, TetradX, TetradY, Color)
% Whereas:
% blkMatrix - The Matrix of the Tetromino
% TetradX - The X position of the tetromino (i.e. the REF point)
% TetradY - The Y position of the tetromino (i.e. the REF point)
% colorIndex - The Color Index (1-7) 

global Playfield_1P;
global Playfield_Color_1P;

global REFPOINT_ON_BLOCK;
global SETTLED_BLOCK;

fail_flag=0;

for i = 1:4
    for j = 1:4
        Playfield_X = TetradX + i - REFPOINT_ON_BLOCK.X;
        Playfield_Y = TetradY + j - REFPOINT_ON_BLOCK.Y;
        if blkMatrix(j,i) ~= 0 
            if Playfield_1P(Playfield_Y,Playfield_X) ~= 0
                fail_flag = 1;
%                 error(['addTetradToPlayfield(): The tetromino overlapped on' ...
%                 ' existing blocks']);
            end
            Playfield_1P(Playfield_Y,Playfield_X) = SETTLED_BLOCK;
            Playfield_Color_1P(Playfield_Y,Playfield_X) = colorIndex;
        end
    end
end
