function [NormalFallSpeed KeySampRate HorizontalMoveCoolDownTime RotateCoolDownTime] = getFallingSpeed(currGameLevel)
%
NormalFallSpeed = (currGameLevel+2)./1.5;        % The ordinary falling speed (in block/sec)
% FreeFallSpeed = 40;         % The free falling speed (in block/sec)
KeySampRate = max(50, NormalFallSpeed.*10);                   % This many keys shall be processed in one sec.
HorizontalMoveCoolDownTime = max(0.03, 0.12 - NormalFallSpeed./100);       % The interval between two horizontal moves
                                        % if the Left or Right key is
                                        % pressed and held (in sec.).
RotateCoolDownTime = max(0.1, 0.5 - NormalFallSpeed./200); % The interval between two turnovers (in sec.).