function [new_blkMatrix new_nOrientation changeFlag] = rotateTetromino...
    (blkMatrix, tetradX, tetradY, nOrientation, tetradIndex)

% rotateTetromino   - rotate a tetromino

global Tetrad_O;
global Tetrad_I;
global Tetrad_J;
global Tetrad_L;
global Tetrad_S;
global Tetrad_Z;
global Tetrad_T;

global TetrisTypeIndex;

global MOVING_BLOCK
global REFPOINT_ON_BLOCK

% there are only 4 orientations for each tetromino
if (nOrientation >=4)
    new_nOrientation = 1;
else
    new_nOrientation = nOrientation + 1;
end

% try to find the new Orientation of a certain type
try
    new_blkMatrix = eval(['Tetrad_' upper(TetrisTypeIndex(tetradIndex)) '(:,:,new_nOrientation);']);
catch
    error('rotateBlock(): unrecognizabke tetromino type');
end

for i =1:4
    bricks_x = find(new_blkMatrix(i,:) == MOVING_BLOCK);
    bricks_x = tetradX + bricks_x - REFPOINT_ON_BLOCK.X;
    
    % construct equal number of 'bricks_y' to 'bricks_x';
    bricks_y = repmat(i + tetradY - REFPOINT_ON_BLOCK.Y, size(bricks_x));
    
    if (out_of_Bound(bricks_x, bricks_y)||is_a_Fixed_Block(bricks_x, bricks_y))
        new_blkMatrix = blkMatrix;
        new_nOrientation = nOrientation;
        changeFlag = 0;
        return;
    end
end
    
changeFlag = 1;
return