function tetrisGameEnding(status, finalScore)
% TETRISGAMEENDING - Display messages and menus after player wins or loses the game
% status = 0: lose, 1: win
% finalScore: your final score, neglected when status == 0
global w
global winRect
global woff_whole
global tex_GameOver size_GameOver
global tex_Ending size_Ending

global GameRank
global GameRankScore
global theLevelPlayerStartsFrom
global nLinesForEachLevel

global ResFactor
global elapsedTime
global TimeLimit

if ~exist('status','var')
    status = 1;
end

% Screen('CopyWindow', w, woff_whole, [], []);
% Screen('BlendFunction', w, SRC_ALPHA, ONE_MINUS_SRC_ALPHA);
% Screen('DrawTexture', w, woff_whole);
% Screen('FillRect', w, [128 0 0 128], winRect);    % Grey out the entire scene
        arr = zeros(768,1024,4);
        arr(:,:,4) = ones(768,1024)*80;
        tex = Screen('MakeTexture', w, arr);
        Screen('DrawTexture', w, tex, [], winRect);
        Screen('Flip',w, [], 1);

if status == 0 || 2
    % Get the aligned rect of the texture
    rect_GameOver = getAlignedRect(size_GameOver([2 1]), winRect, 'center', 'center');
    Screen('DrawTexture', w, tex_GameOver, [], rect_GameOver);
    if status == 2   % If time's up
        scorestring = sprintf('Your final score is: %ld', finalScore); 
        DrawFormattedText(w, scorestring, 'center',  500.*ResFactor(2), [200 200 200]);
    end
elseif status == 1
    Screen('TextSize', w, round(32.*ResFactor(2)));
    Screen('TextFont', w, 'Arial Black');
    Screen('DrawTexture', w, tex_Ending, [], winRect);
%     showText(num2str(finalScore), 'Arial Black', 32, {'center', 300}, [0 128 255],[0 0 0 0])
    Screen('TextBackgroundColor', w, [0 0 0]);
    DrawFormattedText(w, num2str(finalScore), 'center', 300.*ResFactor(2), [200 200 200]);
    if theLevelPlayerStartsFrom ~=1
        % In case the player does not start from level 1, the program presumes
        % the player started from level 1 and the only cleared 'single
        % line's until the level reaches theLevelPalyerStartsFrom. 
        addedScore = sum(nLinesForEachLevel(1:theLevelPlayerStartsFrom-1)); 
    else
        addedScore = 0;
    end
    index = find((finalScore + addedScore) >= GameRankScore, 1, 'last');
%     showText(GameRank{index}, 'Arial Black', 32, {'center', 500}, [0 128 255],[0 0 0 0])
    Screen('TextBackgroundColor', w, [0 0 0]);
    DrawFormattedText(w, GameRank{index}, 'center',  500.*ResFactor(2), [200 200 200]);    
    
end

while KbCheck
end
Screen('Flip',w, [], 1);
WaitSecs(1);
   Screen('TextSize', w, round(16.*ResFactor(1)));
    Screen('TextFont', w, 'Helvetica');
Screen('TextBackgroundColor', w, [0 0 0]);
if TimeLimit == 0 || elapsedTime >= TimeLimit   % If you don't need to consider the time limit
    DrawFormattedText(w, 'PRESS ANY KEY TO RETURN TO MAIN MENU', 'center',  700.*ResFactor(2), [255 255 255]);
elseif elapsedTime < TimeLimit
    DrawFormattedText(w, 'PRESS ANY KEY TO RESTART', 'center',  700.*ResFactor(2), [255 255 255]);
end
Screen('Flip',w, [], 1);
while~KbCheck
end


