function [nMoreLinesBeforeNextLevel currLevel] = tetrisGetRemainedLevels(nTotalClearedLines,nLinesForEachLevelCurr, theLevelPlayerStartsFrom)
% Get how many more lines to clear before you can go to the next level

% This is the number of lines the player does not actually clear, but the
% system assumes 
% virtuallyClearedLines = nLinesForEachLevel(1:theLevelPlayerStartsFrom-1);

% Accumulated 'Goal Array' for Each Level
sumLinesForEachLevelCurr = nLinesForEachLevelCurr;
for i = 1: length(nLinesForEachLevelCurr)
    sumLinesForEachLevelCurr(i) = sum(nLinesForEachLevelCurr(1:i));
end

% Find the next level
nextLevelInd = find(sumLinesForEachLevelCurr>nTotalClearedLines, 1, 'first'); 

nMoreLinesBeforeNextLevel = sumLinesForEachLevelCurr(nextLevelInd) - nTotalClearedLines;

currLevel = theLevelPlayerStartsFrom + nextLevelInd - 1; % Get the current Game Level