function [newScore increment] = tetrisUpdateScore(currScore, lastInc, currPsychStatus, currPsychLines, currComboTimes)
% TETRISUPDATESCORE: Renew the current score
% USAGE:
% - Input: 
%   currScore: current score before being updated
%   lastInc: How many score were added when the score was last updated
%   currPsychStatus: 1~4 (the time of combo performed)
%   currPsychLines: 1~4 (the number of lines cleared)
%   currComboTimes: 1~inf (the number of combo performed - 3)
global TETRIS_CONTEXT

if strcmpi(TETRIS_CONTEXT, 'psych')
    score_inc = [10 25 45 70];
else
    score_inc = [10 25 45 70];
end
score_mul = [1 2 4 8];
if nargin == 1
    if strcmpi(TETRIS_CONTEXT, 'psych')
        increment = 3;
    else
        increment = 3;
    end
else
    if currPsychStatus == 1
        increment = score_inc(currPsychLines);
    else
        increment = score_inc(currPsychLines);
%         increment = score_inc(currPsychLines).*(score_mul(currPsychLines)).^(currPsychStatus-1);
    end
end

newScore = currScore + increment;
            
    