function drawOneBlockPF(xy, color)
% DRAWONEBLOCK      Display one square block on screen
% Usage:
%   drawOneBlock(xy, color)
%   xy    -   [x y] of the top left coordinate relative to the origin of
%   play field: [1 1] is the coordinate of origin
%   color   -   color of the block ('color_' + 'o', 's', 'z', 'l', 'j','i','t')

global w;

global BLOCK_SIZE;
global PF_TOPXY_INT;

global tex_BlockShade;

xy = (xy - [1 1]).*BLOCK_SIZE + PF_TOPXY_INT; % convert from pf coordinate to screen coordinate

blockrect = [xy xy]+[0 0 BLOCK_SIZE];

Screen('FillRect', w, color, blockrect);

Screen('DrawTexture', w, tex_BlockShade, [], blockrect);