function hideLines(lines)
% HIDELINES - Temporarily hide a line for some special animation effects
% Usage:
%   hideLines(lines)
% whereas
%   'lines'  - gives the lines to hide

global w;
global BLOCK_SIZE;
global PF_WIDTH_INT;
global PF_TOPXY_INT;
global PF_BACKGROUND_COLOR;

if isempty(lines)       % Do nothing if there are no lines to hide
    return;
end

nLines = length(lines);     % Get the number of lines

for i = 1:nLines
    lefttop = PF_TOPXY_INT + [0 (lines(i)-1)*BLOCK_SIZE(2)];
    rightbottom = lefttop + [PF_WIDTH_INT.*BLOCK_SIZE(1) BLOCK_SIZE(2)];
    Screen('FillRect', w, PF_BACKGROUND_COLOR, [lefttop rightbottom]);
end