function redrawPlayfieldPF(startline, endline)
%REDRAWPLAYFIELDPF    - Refresh the Playfield

global w;
global Playfield_1P;
global Playfield_Color_1P;
global PF_HEIGHT_INT;
global PF_WIDTH_INT;
global PF_TOPXY_INT;
global TetradColor;
global SETTLED_BLOCK;
global BLOCK_SIZE;
global PF_BACKGROUND_COLOR;

if nargin < 2
    endline = PF_HEIGHT_INT;
end
if nargin < 1
    startline = 1;
end

if endline < startline
    error('redrawPlayfield(): ''endline'' is less than ''startline''');
end

clearRect = [PF_TOPXY_INT(1), PF_TOPXY_INT(2)+(startline-1).*BLOCK_SIZE(2), PF_TOPXY_INT(1)+PF_WIDTH_INT.* BLOCK_SIZE(1), PF_TOPXY_INT(2)+(endline).*BLOCK_SIZE(2)];
        
Screen('FillRect',w, PF_BACKGROUND_COLOR, clearRect);

for i = startline : endline
    for j = 1: PF_WIDTH_INT
        if (Playfield_1P(i,j) == SETTLED_BLOCK)
            % Get the [x y] coordinate for the current block
            xy = [j,i];     
            % Draw the current block
            drawOneBlockPF(xy, TetradColor(Playfield_Color_1P(i,j),:));
        end
    end
end