function [textStructBackup] = showText(textStr, fonttype, fontsize, position, textcolor, textbkgcolor)
% Display one line of text 
% position can be 1 x 2 array which specifies the [x y] pair, or it can be
% strings: 'center'
global w
global winRect
global Flip_Interval    



if nargin == 1  % Use the structure styled argument
    if isfield(textStr,'LifeTime') && textStr.LifeTime <= 0 % Never print those dead texts
        return;
    end
    textStructBackup = textStr;     % Back this structure up for later use
    
    textbkgcolor = textStr.BkgColor;
        textcolor = textStr.Color;
        position = textStr.Position;

    fontsize = textStr.Size;
    fonttype = textStr.Font;

    textStr = textStr.String;
else
    textStructBackup = [];
end

if isempty(textStr)
    return;
end
    

oldfont = Screen('TextFont', w, fonttype);
oldsize = Screen('TextSize', w, fontsize);

if exist('textbkgcolor','var') && ~isempty(textbkgcolor)
    oldbkgcolor = Screen('TextBackgroundColor', w, textbkgcolor);
end

if ~isempty(nonzeros(textcolor<0))  % If minus color appears
    textStructBackup.Color = textbkgcolor;
    return;
end

if ischar(position)
    if strcmp(position, 'center')
        textrect = Screen('TextBounds', w, textStr, 0, 0);
        x = ((winRect(3) - winRect(1)) - (textrect(3) - textrect(1)))./2;
        y = ((winRect(4) - winRect(2)) - (textrect(4) - textrect(2)))./2;
        position = [x y];
    end
elseif iscell(position)
    if strcmp(position{1}, 'center') && isnumeric(position{2})
        textrect = Screen('TextBounds', w, textStr, 0, 0);
        x = ((winRect(3) - winRect(1)) - (textrect(3) - textrect(1)))./2;
        y = position{2};
        position = [x y];
    elseif strcmp(position{2}, 'center') && isnumeric(position{1})
        textrect = Screen('TextBounds', w, textStr, 0, 0);
        y = ((winRect(4) - winRect(2)) - (textrect(4) - textrect(2)))./2;
        x = position{1};
        position = [x y];
    else
        position = [position{1}, position{2}];
    end
end

textStr(strcmp(textStr,''))= [];    % Remove possible empty string 
% 
% textStr
% position
% textcolor
if iscell(textStr)
for i = 1:length(textStr)
    if i == 1
            Screen('DrawText', w, textStr{i}, position(1), position(2),textcolor);
    else
        position(2) = position(2) + fontsize.*1.2;      % The next line
        Screen('DrawText', w, textStr{i}, position(1), position(2),textcolor);
    end
end
else
     Screen('DrawText', w, textStr, position(1), position(2),textcolor);
end

Screen('TextFont', w, oldfont);
Screen('TextSize', w, oldsize);

if exist('oldbkgcolor', 'var')
    Screen('TextBackgroundColor', w, oldbkgcolor);
end
    
if isfield(textStructBackup, 'LifeTime')
     textStructBackup.LifeTime = textStructBackup.LifeTime - Flip_Interval; % Predicted LifeTime
     textStructBackup.Position = textStructBackup.Position + textStructBackup.PosDiff.*Flip_Interval;
     textStructBackup.Color = textStructBackup.Color - textStructBackup.Color.*Flip_Interval;
end