% Menu Initialization
function menuInit

global menuProperties
global menuEntries
global inGameMenuProperties
global inGameMenuEntries

global ResFactor
% ####### Confirm Dialog ###############

confirmEntries(1).Caption = 'Are you sure?';

confirmEntries(1).Type = 'texttag';

confirmEntries(1).Enabled = false;

confirmEntries(1).Font = 'Arial Black';

confirmEntries(1).Size = round(20*ResFactor(1));

confirmEntries(1).Color = [0 255 255];

confirmEntries(1).BindedVariable = '';

% ************************************

confirmEntries(2).Caption = 'Yes';

confirmEntries(2).Type = 'return';

confirmEntries(2).Enabled = true;

confirmEntries(2).Font = 'Arial Black';
confirmEntries(2).Size = round(16*ResFactor(1));
confirmEntries(2).Color = [255 255 255];

confirmEntries(2).ReturnCode = {
                    'Screen(''BlendFunction'', w, GL_ONE, GL_ZERO);'
                'Screen(''DrawTexture'', w, menuOffWin, [], menuRect);'
                'Screen(''BlendFunction'', w, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);'
                'returnEntry = 5;'
                'returnCode = ''return'';'    % May need to change this to 'quit' or something  
                'return'};

% ***********************************

confirmEntries(3).Caption = 'No';

confirmEntries(3).Type = 'return';

confirmEntries(3).Enabled = true;

confirmEntries(3).Font = 'Arial Black';
confirmEntries(3).Size = round(16*ResFactor(1));
confirmEntries(3).Color = [255 255 255];

confirmEntries(3).ReturnCode = '';

confirmProperties.HighLightedTextColor = [255 255 0];
confirmProperties.HighLightedBkgColor = [0 0 255];
confirmProperties.MenuBkgColor = [128 128 255 128];
confirmProperties.MenuFrameColor = [255 255 255];

confirmProperties.DefaultEntry = 3;        % The default entry as seen when the menu was displayed for the first time
confirmProperties.ClearParent = true;
confirmProperties.MenuPosition = [-1, 500*ResFactor(2)]; % -1 for center on the screen
confirmProperties.MenuSize = 'auto';   % Auto-adjusted according to the text size
confirmProperties.EntryVertSpacing = 15*ResFactor(1);   %
confirmProperties.HoriMargin = 30*ResFactor(1);
confirmProperties.VertMargin = 10*ResFactor(1);
confirmProperties.EntriesAlignment = 'center'; % 'left', 'right'
confirmProperties.RefractoryTime = 0.4; % Keypresses shall be responded once every this much time
confirmProperties.EnableEscape = true;
confirmProperties.DefaultReturnEntry = 2;
% ######################################

keyConfigEntries(1).Caption = 'LEFT   ';

keyConfigEntries(1).Type = 'setkey';

keyConfigEntries(1).Enabled = true;

keyConfigEntries(1).Font = 'Arial Black';

keyConfigEntries(1).Color = [255 255 255];
keyConfigEntries(1).Size = round(16*ResFactor(1));

keyConfigEntries(1).BindedVariable = 'LeftKey';
keyConfigEntries(1).CurrValue = GetGlobalValue(keyConfigEntries(1).BindedVariable);
keyConfigEntries(1).Spacing = 30*ResFactor(1);

keyConfigEntries(1).ReturnCode = '';

% **************************************


keyConfigEntries(2).Caption = 'RIGHT ';

keyConfigEntries(2).Type = 'setkey';

keyConfigEntries(2).Enabled = true;

keyConfigEntries(2).Font = 'Arial Black';

keyConfigEntries(2).Color = [255 255 255];
keyConfigEntries(2).Size = round(16*ResFactor(1));
keyConfigEntries(2).BindedVariable = 'RightKey';
keyConfigEntries(2).CurrValue = GetGlobalValue(keyConfigEntries(2).BindedVariable);
keyConfigEntries(2).Spacing = 30*ResFactor(1);

keyConfigEntries(2).ReturnCode = '';
% **************************************


keyConfigEntries(3).Caption = 'DOWN ';

keyConfigEntries(3).Type = 'setkey';

keyConfigEntries(3).Enabled = true;

keyConfigEntries(3).Font = 'Arial Black';

keyConfigEntries(3).Color = [255 255 255];
keyConfigEntries(3).Size = round(16*ResFactor(1));
keyConfigEntries(3).BindedVariable = 'DownKey';
keyConfigEntries(3).CurrValue = GetGlobalValue(keyConfigEntries(3).BindedVariable);
keyConfigEntries(3).Spacing = 30*ResFactor(1);

keyConfigEntries(3).ReturnCode = '';


% *************************************


keyConfigEntries(4).Caption = 'ROTATE';

keyConfigEntries(4).Type = 'setkey';

keyConfigEntries(4).Enabled = true;

keyConfigEntries(4).Font = 'Arial Black';
keyConfigEntries(4).Size = round(16*ResFactor(1));
keyConfigEntries(4).Color = [255 255 255];

keyConfigEntries(4).BindedVariable = 'TurnKey';
keyConfigEntries(4).CurrValue = GetGlobalValue(keyConfigEntries(4).BindedVariable);
keyConfigEntries(4).Spacing = round(30*ResFactor(1));

keyConfigEntries(4).ReturnCode = '';

% ****************************************


keyConfigEntries(5).Caption = 'BACK';

keyConfigEntries(5).Type = 'return';

keyConfigEntries(5).Enabled = true;

keyConfigEntries(5).Font = 'Arial Black';
keyConfigEntries(5).Size = round(16*ResFactor(1));
keyConfigEntries(5).Color = [255 255 255];

keyConfigEntries(5).BindedVariable = '';
keyConfigEntries(5).Spacing = 0*ResFactor(2);

keyConfigEntries(5).ReturnCode = '';


keyConfigEntries(6).Caption = 'PRESS ENTER TO SET KEYS';

keyConfigEntries(6).Type = 'texttag';

keyConfigEntries(6).Enabled = false;

keyConfigEntries(6).Font = 'Arial Black';
keyConfigEntries(6).Size = round(16*ResFactor(1));
keyConfigEntries(6).Color = [128 255 255];

keyConfigEntries(6).BindedVariable = '';

keyConfigEntries(6).Spacing = 0*ResFactor(1);

keyConfigEntries(6).ReturnCode = '';


% *************************************
keyConfigProperties.HighLightedTextColor = [255 255 0];
keyConfigProperties.HighLightedBkgColor = [0 0 255];
keyConfigProperties.MenuBkgColor = [128 128 255 128];
keyConfigProperties.MenuFrameColor = [255 255 255];

keyConfigProperties.ClearParent = true;
keyConfigProperties.MenuPosition = [-1 500*ResFactor(2)]; % center on the screen
keyConfigProperties.MenuSize = 'auto';   % Auto-adjusted according to the text size
keyConfigProperties.HoriMargin = 20*ResFactor(1);
keyConfigProperties.VertMargin = 20*ResFactor(2);
keyConfigProperties.EntryVertSpacing = 5*ResFactor(2);
keyConfigProperties.EntriesAlignment = 'center'; % 'left', 'right'
keyConfigProperties.LongestKeyName = 'RightArrow';  % The longest possible text?  
keyConfigProperties.DefaultEntry = 1;
keyConfigProperties.EnableEscape = true;
keyConfigProperties.DefaultReturnEntry = 5; % This value does not really matter 
keyConfigProperties.RefractoryTime = 0.4;
% #####################################

optionEntries(1).Caption = 'MUSIC VOLUME';

optionEntries(1).Type = 'enum';

optionEntries(1).Enabled = true;

optionEntries(1).Font = 'Arial Black';

optionEntries(1).Color = [255 255 255];

optionEntries(1).BindedVariable = 'MusicVolume';

optionEntries(1).CurrValue = GetGlobalValue(optionEntries(1).BindedVariable);

optionEntries(1).Size = round(16*ResFactor(1));
optionEntries(1).Limits = [0 10];

optionEntries(1).Spacing = 30;

optionEntries(1).ReturnCode = 'global MusicSource; global AL;'; % % alSourcef(MusicSource, AL.GAIN, MusicVolume./10);';

% **********************************

optionEntries(2).Caption = 'SOUND FX VOLUME';

optionEntries(2).Type = 'enum';

optionEntries(2).Enabled = true;

optionEntries(2).Font = 'Arial Black';

optionEntries(2).Color = [255 255 255];

optionEntries(2).BindedVariable = 'SoundVolume';

optionEntries(2).CurrValue = GetGlobalValue(optionEntries(2).BindedVariable);

optionEntries(2).Size = round(16*ResFactor(1));

optionEntries(2).Limits = [0 10];

optionEntries(2).Spacing = 30*ResFactor(1);

optionEntries(2).ReturnCode = '';

% ***********************************

optionEntries(3).Caption = 'KEYBOARD CONFIG';

optionEntries(3).Type = 'submenu';

optionEntries(3).Enabled = true;

optionEntries(3).Font = 'Arial Black';

optionEntries(3).Size = round(16*ResFactor(1));

optionEntries(3).Color = [255 255 255];

optionEntries(3).BindedVariable = '';

optionEntries(3).SubMenuEntries = keyConfigEntries;

optionEntries(3).SubMenuProperties = keyConfigProperties;
optionEntries(3).Limits = [];

optionEntries(3).Spacing = 30*ResFactor(1);

optionEntries(3).ReturnCode = '';

optionProperties.HighLightedTextColor = [255 255 0];
optionProperties.HighLightedBkgColor = [0 0 255];
optionProperties.MenuBkgColor = [128 128 255 128];
optionProperties.MenuFrameColor = [255 255 255];

optionProperties.DefaultEntry = 1;        % The default entry as seen when the menu was displayed for the first time
optionProperties.ClearParent = true;
optionProperties.MenuPosition = [-1, 500*ResFactor(2)]; % -1 for center on the screen
optionProperties.MenuSize = 'auto';   % Auto-adjusted according to the text size
optionProperties.EntryVertSpacing = 5*ResFactor(2);   %
optionProperties.HoriMargin = 50*ResFactor(1);
optionProperties.VertMargin = 10*ResFactor(2);
optionProperties.EntriesAlignment = 'center'; % 'left', 'right'
optionProperties.RefractoryTime = 0.4; % Keypresses shall be responded once every this much time
optionProperties.EnableEscape = true;
optionProperties.DefaultReturnEntry = 4;
% ***************************************

optionEntries(4).Caption = 'TIME LIMIT(sec)';

optionEntries(4).Type = 'enum';

optionEntries(4).Enabled = true;

optionEntries(4).Font = 'Arial Black';

optionEntries(4).Color = [255 255 255];

optionEntries(4).Size = round(16*ResFactor(1));

optionEntries(4).BindedVariable = 'TimeLimit';
optionEntries(4).CurrValue = GetGlobalValue(optionEntries(4).BindedVariable);
optionEntries(4).Limits = [0 60000];
optionEntries(4).ReturnCode = '';
optionEntries(4).Spacing = 30*ResFactor(1);
% *************************************

optionEntries(5).Caption = 'BACK';

optionEntries(5).Type = 'return';

optionEntries(5).Enabled = true;

optionEntries(5).Font = 'Arial Black';

optionEntries(5).Color = [255 255 255];

optionEntries(5).Size = round(16*ResFactor(1));

optionEntries(5).ReturnCode = '';

% #########################################

%---------------------------------------
menuEntries(1).Caption = 'START';

menuEntries(1).Type = 'return';

menuEntries(1).Enabled = true;

menuEntries(1).Font = 'Arial Black';

menuEntries(1).Color = [255 255 255];

menuEntries(1).Size = round(16*ResFactor(1));

menuEntries(1).BindedVariable = '';

menuEntries(1).ReturnCode = 'Screen(''DrawText'',w, ''You pressed STart!'', 25, 25, [255 255 255]);';

% ----------------------------------------
menuEntries(2).Caption = 'LEVEL';

menuEntries(2).Type = 'enum';

menuEntries(2).Enabled = true;

% menuEntries(2).Default = 1;
menuEntries(2).Font = 'Arial Black';

menuEntries(2).Color = [255 255 255];

menuEntries(2).Size = round(16*ResFactor(1));

menuEntries(2).BindedVariable = 'theLevelPlayerStartsFrom';

menuEntries(2).CurrValue = GetGlobalValue(menuEntries(2).BindedVariable);
menuEntries(2).Limits = [1 10];     % Minimum and Maximum Value of currLevel

% menuEntries(2).LongestText = '10';  % The longest possible number

menuEntries(2).Spacing = 15*ResFactor(1);        % The space between the entry and the number

menuEntries(2).ReturnCode = '';



% ---------------------------------------

menuEntries(3).Caption = 'OPTIONS';

menuEntries(3).Type = 'submenu';

menuEntries(3).Enabled = true;

menuEntries(3).Font = 'Arial Black';

menuEntries(3).Color = [255 255 255];

menuEntries(3).Size = round(16*ResFactor(1));

menuEntries(3).BindedVariable = '';

menuEntries(3).Limits = [];

menuEntries(3).ReturnCode = '';

menuEntries(3).SubMenuEntries = optionEntries; 

menuEntries(3).SubMenuProperties = optionProperties; 
% ------------------------------------------

menuEntries(4).Caption = 'CREDIT';

menuEntries(4).Type = 'subfunc';    % Execute a subfunction, but do not return the status to user

menuEntries(4).Enabled = true;

menuEntries(4).Font = 'Arial Black';

menuEntries(4).Color = [255 255 255];

menuEntries(4).Size = round(16*ResFactor(1));

menuEntries(4).BindedVariable = '';

menuEntries(4).Limits = [];

menuEntries(4).ReturnCode = {'wholeScreenOffWindow = Screen(''OpenOffScreenWindow'',w,0);'      % Save the original screen
                             'Screen(''CopyWindow'', w, wholeScreenOffWindow);'
                             'Screen(''Flip'',w, 0);'
                             'tetrisTextScroll;'                                                % Roll the text!
                             'Screen(''BlendFunction'', w, GL_ONE, GL_ZERO);'
                             'Screen(''DrawTexture'',w, wholeScreenOffWindow);'                 % Restore the screen
                             'Screen(''BlendFunction'', w, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);'
                             'Screen(''Close'',wholeScreenOffWindow);'
                             'menuFirstKeyReleased = 0;'         % Disable key responsiveness until all keys are released
                             'menuStatusChanged = 1;'            % The last two lines are required
                             'global MusicSource;'              % Restore the music
                             'global OpeningMusicBuffer;'
                             };
% %                              'alSourceStop(MusicSource);'
% %                              'alSourceUnqueueBuffers(MusicSource, 1);'
% %                              'alSourceQueueBuffers(MusicSource, 1, OpeningMusicBuffer);'
% %                              'alSourcei(MusicSource, AL.LOOPING, AL.TRUE);'
% %                              'alSourcePlay(MusicSource);'
% %                              };
% ------------------------------------------

menuEntries(5).Caption = 'EXIT';

menuEntries(5).Type = 'submenu';

menuEntries(5).Enabled = true;

menuEntries(5).Font = 'Arial Black';

menuEntries(5).Color = [255 255 255];

menuEntries(5).Size = round(16*ResFactor(1));

menuEntries(5).BindedVariable = '';

menuEntries(5).Limits = [];

menuEntries(5).SubMenuEntries = confirmEntries;
% menuEntries(5).SubMenuEntries(2).returnCode = 
menuEntries(5).SubMenuProperties = confirmProperties;
menuEntries(5).ReturnCode = 'return;';

% -----------------------------------------



menuProperties.HighLightedTextColor = [255 255 0];
menuProperties.HighLightedBkgColor = [0 0 255];
menuProperties.MenuBkgColor = [128 128 255 128];    % Transparent Menu
menuProperties.MenuFrameColor = [255 255 255];      % White Frame

menuProperties.DefaultEntry = 1;        % The default entry as seen when the menu was displayed for the first time
menuProperties.ClearParent = true;
menuProperties.MenuPosition = [-1, 500*ResFactor(2)]; % -1 for center on the screen
menuProperties.MenuSize = 'auto';   % Auto-adjusted according to the text size
menuProperties.EntryVertSpacing = 5*ResFactor(2);   % Vertical spacing between two items
menuProperties.HoriMargin = 30*ResFactor(1);     % The space between the topmost item and the top of the frame
menuProperties.VertMargin = 10*ResFactor(2);
menuProperties.EntriesAlignment = 'center'; % 'left', 'right'
menuProperties.RefractoryTime = 0.4; % Keypresses shall be responded once every this much time

menuProperties.EnableEscape = false;
menuProperties.DefaultReturnEntry = 5;
% menuProperties.MenuOffWin = [];     % Off screen window contains the content in the menu area before
%                                     % the menu is drawn. Used to restore.
% menuProperties.MenuRect = [];       % Used to point out where to draw the menu                                    
                     
% ****************************************************************

% The In-Game Menu
%---------------------------------------
inGameMenuEntries(1).Caption = 'RESUME';

inGameMenuEntries(1).Type = 'return';

inGameMenuEntries(1).Enabled = true;

inGameMenuEntries(1).Font = 'Arial Black';

inGameMenuEntries(1).Color = [255 255 255];

inGameMenuEntries(1).Size = round(16*ResFactor(1));

inGameMenuEntries(1).BindedVariable = '';

inGameMenuEntries(1).ReturnCode = '';

% ---------------------------------------

inGameMenuEntries(2).Caption = 'OPTIONS';

inGameMenuEntries(2).Type = 'submenu';

inGameMenuEntries(2).Enabled = true;

inGameMenuEntries(2).Font = 'Arial Black';

inGameMenuEntries(2).Color = [255 255 255];

inGameMenuEntries(2).Size = round(16*ResFactor(1));

inGameMenuEntries(2).BindedVariable = '';

inGameMenuEntries(2).Limits = [];

inGameMenuEntries(2).ReturnCode = '';

inGameMenuEntries(2).SubMenuEntries = optionEntries; 

inGameMenuEntries(2).SubMenuProperties = optionProperties; 

inGameMenuEntries(2).SubMenuEntries(4).Enabled = false;   % Disable time setting in the game
% ------------------------------------------

inGameMenuEntries(3).Caption = 'BACK TO MAIN MENU';

inGameMenuEntries(3).Type = 'submenu';    % Execute a subfunction, but do not return the status to user

inGameMenuEntries(3).Enabled = true;

inGameMenuEntries(3).Font = 'Arial Black';

inGameMenuEntries(3).Color = [255 255 255];

inGameMenuEntries(3).Size = round(16*ResFactor(1));

inGameMenuEntries(3).BindedVariable = '';

inGameMenuEntries(3).Limits = [];

inGameMenuEntries(3).ReturnCode = 'restart_flag = 1;';
                         
inGameMenuEntries(3).SubMenuEntries = confirmEntries;
inGameMenuEntries(3).SubMenuProperties = confirmProperties;
inGameMenuEntries(3).SubMenuEntries(2).ReturnCode = {    % Not 1, but 2!
                'Screen(''BlendFunction'', w, GL_ONE, GL_ZERO);'
                'Screen(''DrawTexture'', w, menuOffWin, [], menuRect);'
                'Screen(''BlendFunction'', w, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);'
                'returnEntry = 3;'
                'returnCode = ''restart_flag = 1;'';'    % May need to change this to 'quit' or something  
                'return'};
% ------------------------------------------

inGameMenuEntries(4).Caption = 'EXIT GAME';

inGameMenuEntries(4).Type = 'submenu';

inGameMenuEntries(4).Enabled = true;

inGameMenuEntries(4).Font = 'Arial Black';

inGameMenuEntries(4).Color = [255 255 255];

inGameMenuEntries(4).Size = round(16*ResFactor(1));

inGameMenuEntries(4).BindedVariable = '';

inGameMenuEntries(4).Limits = [];

inGameMenuEntries(4).SubMenuEntries = confirmEntries;   % The submenu is a confirmation dialog box
inGameMenuEntries(4).SubMenuProperties = confirmProperties;
inGameMenuEntries(4).SubMenuEntries(2).ReturnCode = {
                'Screen(''BlendFunction'', w, GL_ONE, GL_ZERO);'
                'Screen(''DrawTexture'', w, menuOffWin, [], menuRect);'
                'Screen(''BlendFunction'', w, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);'
                'returnEntry = 4;'
                'returnCode = ''esc_flag = 1;'';'    % Consider using non-executable CODE as returnCode such as 'QUIT' 
                'return'};
inGameMenuEntries(4).ReturnCode =  {
                'Screen(''BlendFunction'', w, GL_ONE, GL_ZERO);'
                'Screen(''DrawTexture'', w, menuOffWin, [], menuRect);'
                'Screen(''BlendFunction'', w, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);'
                'returnEntry = 4;'
                'returnCode = ''esc_flag = 1;'';'  
                'return'};

inGameMenuProperties.HighLightedTextColor = [255 255 0];
inGameMenuProperties.HighLightedBkgColor = [0 0 255];
inGameMenuProperties.MenuBkgColor = [128 128 255 128];
inGameMenuProperties.MenuFrameColor = [255 255 255];

inGameMenuProperties.DefaultEntry = 1;        % The default entry as seen when the menu was displayed for the first time
inGameMenuProperties.ClearParent = true;
inGameMenuProperties.MenuPosition = [-1, 500*ResFactor(2)]; % -1 for center on the screen
inGameMenuProperties.MenuSize = 'auto';   % Auto-adjusted according to the text size
inGameMenuProperties.EntryVertSpacing = 5*ResFactor(2);   %
inGameMenuProperties.HoriMargin = 30*ResFactor(1);
inGameMenuProperties.VertMargin = 10*ResFactor(2);
inGameMenuProperties.EntriesAlignment = 'center'; % 'left', 'right'
inGameMenuProperties.RefractoryTime = 0.4; % Keypresses shall be responded once every this period of time

inGameMenuProperties.EnableEscape = true;
inGameMenuProperties.DefaultReturnEntry = 1;

