function oldScreenSettings = tetrisCheckScreenSettings
% TETIRSCHECKSCREENSETTINGS  - Check the screen resolution and color depth
%
% Usage:
% oldScreenSettings = tetrisCheckScreenSettings;
% - Input: None
% - Output: 
% ---- oldScreenSettings: The old screen settings. A struct returned by 
%                         Screen('Resolution')

% Used in:
%  tetrisMain

global ExpectedScreenSettings;
global MonitorNo;

%% These are the only Enviroment Parameters which are not defined in 
%% tetrisEnvironment.m
MonitorNo = max(Screen('Screens'));

% Sorry, only 1024x768x32bit Mode is natively supported as of yet.
ExpectedScreenSettings.width = 1024;
ExpectedScreenSettings.height = 768;
ExpectedScreenSettings.pixelSize = 32;
ExpectedScreenSettings.hz = 0;

oldScreenSettings = Screen('Resolution', MonitorNo, ExpectedScreenSettings.width, ...
                            ExpectedScreenSettings.height, [], ExpectedScreenSettings.pixelSize);
                        