% tetrisPsychSettings
% set the preferences for psychophysicists



reply = [];
quit_flag = 0;
oldvalue = 0;
disp('-- Preferences for MATRIS -- ');

while 1
disp('WARNING: Running this script will clear your workspace!')
reply = input('Do you really wish to continue(y/n)?','s');
    if strcmp(reply, 'n') || strcmp(reply, 'N')
        quit_flag = 1;
        break;
    end
    if strcmp(reply, 'y') || strcmp(reply, 'Y')
        quit_flag = 0;
        break;
    end
end

if quit_flag == 1
    clear reply 
    clear quit_flag
    return;
end

clear all;

Main_Dir = mfilename('fullpath');

thisFileName = mfilename;
Main_Dir = strrep(Main_Dir, thisFileName, '');  % Get the path


Setting_Dir = [Main_Dir 'Settings'];
cd(Setting_Dir);

eval(['load(''' Setting_Dir 'PsychSettings.mat'');']);

disp('** Press ENTER without entering anything to leave the current value unchanged **');

%% Display current preferences
fprintf('\n---------                     --------\n');
fprintf('Variable                       Value\n');
fprintf('---------                     --------\n');
fprintf('TimeLimit                     %d\n', TimeLimit);
fprintf('EnableLevelUp                 %d\n', EnableLevelUp);
fprintf('DataPath                      %s\n', DataPath);
fprintf('--------------- END OF THE LIST ----------------\n');

%% 1. Time Limit
temp = input('The time limit for each session (in secs, 0 to disable the time limit): ');
if ~isempty(temp)
    TimeLimit = temp;
end

%% 2. Level Up
oldvalue = EnableLevelUp;
while 1
temp = input('Do you wish to enable the LevelUp feature? (y/n)', 's');

if isempty(temp)
    EnableLevelUp = oldvalue;    % In case the user inputs illegel values
    break;          % Leave the value unchanged
else
    EnableLevelUp = temp;
end
    
if strcmp(EnableLevelUp, 'y') || strcmp(EnableLevelUp, 'Y') 
    EnableLevelUp = true;
    break;
elseif strcmp(EnableLevelUp, 'n') || strcmp(EnableLevelUp, 'N') 
    EnableLevelUp = false;
    break;
end
end

%% 3. Data path
while 1
    temp = input('Specify the path to store the data (must be an existing path):  ', 's');

    if ~isempty(temp)
        DataPath = temp;
    end

    if ~exist(DataPath,'dir')
        disp('The specified path does not exist. Make sure you have entered the correct path.');
        continue;
    else
        break;
    end
end
clear Main_Dir
clear thisFileName
clear Setting_Dir
clear temp
clear oldvalue;

eval(['save(''PsychSettings.mat'');']);
disp('Preferences Saved');
