%function tetrisSubjectInfo
% TETRISSUBJECTINFO - Asks for the information of the subject

global SUBJECT_CODE
global TimeLimit
global DataPath
global SUBJECT_FILENAME

SUBJECT_CODE = input('Subject Code:    ','s');
DataPath = [DataPath filesep SUBJECT_CODE];

if ~exist(DataPath, 'dir')
    mkdir(DataPath);
    fprintf('\n%s does not exist. Creating...Done\n', DataPath);
end


currDir = pwd;  % Backup the current Directory

cd (DataPath);  % Change the current Dir



% SESSION_INFO.date = datestr(date);       

SUBJECT_FILENAME = [SUBJECT_CODE '_' datestr(date, 'yymmdd')];  % e.g. 'JS_090718' means July 18, 2009 

currentFiles = dir([SUBJECT_FILENAME '*']);

if isempty(currentFiles)       
   SUBJECT_FILENAME = [SUBJECT_FILENAME '_001.txt']; 
else                                % If another file 'JS_090718_01'.txt exist, start a new one 'JS_090718_02.txt'
    currentFiles = sortrows(currentFiles);
    mostRecentFile = currentFiles(end, :);      % Get the name of the most recently saved file
    mostRecentFile = strrep(mostRecentFile, [SUBJECT_FILENAME, '_'], '');
    currentFileNum = str2num(strrep(mostRecentFile, '.txt',''));     % Get the largest file number
    
    fprintf('There are already %d files starting with %s:\n', size(currentFiles, 1), SUBJECT_FILENAME);
    ls([SUBJECT_FILENAME '*']);
    
    currentFileNum = currentFileNum + 1;
    
    currentFileNumStr = tetrisNumPadding(currentFileNum, 3, '0');
    
    SUBJECT_FILENAME = [SUBJECT_FILENAME '_' currentFileNumStr '.txt'];    
end

fprintf('The name of the data file:  %s\n', SUBJECT_FILENAME);
temp = input('Press ENTER key to start...');
    

